<?php

/**
 * inf_concep_liqui_detalle actions.
 *
 * @package    nomina
 * @subpackage inf_concep_liqui_detalle
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_concep_liqui_detalleActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by concepto, id_tipo_doc, num_doc ';
        }



        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //concepto nomina
            if (isset($request['id_concep_nomina'])) {
                $whereConcepto = " AND tab0.id_concep_nomina = " . $request['id_concep_nomina'];
            } else {
                $whereConcepto = ' ';
            }
            //tipo concepto
            if (isset($request['id_tipo_concepto'])) {
                $whereTipoConcepto = " AND tab0.id_tipo_concepto = " . $request['id_tipo_concepto'];
            } else {
                $whereTipoConcepto = ' ';
            }
            //clase planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(

select 
tab.codigo as codigo_clapla,
tab.descripcion as descripcion_clapla, 
tab.id_clase_planta,
tab1.id_periodo,
tab4.id_tipo_concepto as id_tipo_concepto,
tab4.descripcion as tipo_concepto,
tab3.id_concep_nomina,
tab3.id_acreedor,
tab3.codigo,
tab3.descripcion,
tab3.codigo||' - '||tab3.descripcion AS CONCEPTO,
tab5.razon_soc as beneficiario,
tab2.id_tipo_doc,
tab2.num_doc as num_doc, 
tab2.nombre_apellido as nombre, 
tab1.valor_liquidado AS VALOR

from no_liquida_nomina tab1

left join no_datos_funcionario_v tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
left join no_concep_nomina tab3 ON tab3.id_concep_nomina = tab1.id_concep_nomina
left join no_tipo_concepto tab4 ON tab4.id_tipo_concepto = tab3.id_tipo_concepto
left join interceros_v tab5 ON tab5.id_mae_ter = tab3.id_acreedor

left join (
         select 
         clapla.codigo,
         clapla.descripcion,
         nom.*,
          case when tab.num_doc is not null then 1 else 0 end as pago
          from no_nombramiento_v nom
          
          join no_clase_planta clapla
          on clapla.id_clase_planta = nom.id_clase_planta

          left join (select distinct
          pago.id_tipo_doc,
          pago.num_doc
          from no_pago_func pago
          where
          (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) 
              between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
          )tab
          on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc
)tab 
on tab.id_tipo_doc = tab1.id_tipo_doc and tab.num_doc = tab1.num_doc

)tab0

where tab0.id_periodo = $periodo_filtro
$whereConcepto  $whereTipoConcepto 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereClasePlanta
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(

select 
tab.codigo as codigo_clapla,
tab.descripcion as descripcion_clapla, 
tab.id_clase_planta,
tab1.id_periodo,
tab4.id_tipo_concepto as id_tipo_concepto,
tab4.descripcion as tipo_concepto,
tab3.id_concep_nomina,
tab3.id_acreedor,
tab3.codigo,
tab3.descripcion,
tab3.codigo||' - '||tab3.descripcion AS CONCEPTO,
tab5.razon_soc as beneficiario,
tab2.id_tipo_doc,
tab2.num_doc as num_doc, 
tab2.nombre_apellido as nombre, 
tab1.valor_liquidado AS VALOR

from no_liquida_nomina tab1

left join no_datos_funcionario_v tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
left join no_concep_nomina tab3 ON tab3.id_concep_nomina = tab1.id_concep_nomina
left join no_tipo_concepto tab4 ON tab4.id_tipo_concepto = tab3.id_tipo_concepto
left join interceros_v tab5 ON tab5.id_mae_ter = tab3.id_acreedor

left join (
         select 
         clapla.codigo,
         clapla.descripcion,
         nom.*,
          case when tab.num_doc is not null then 1 else 0 end as pago
          from no_nombramiento_v nom
          
          join no_clase_planta clapla
          on clapla.id_clase_planta = nom.id_clase_planta

          left join (select distinct
          pago.id_tipo_doc,
          pago.num_doc
          from no_pago_func pago
          where
          (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) 
              between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
          )tab
          on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc
)tab 
on tab.id_tipo_doc = tab1.id_tipo_doc and tab.num_doc = tab1.num_doc


)tab0

where tab0.id_periodo = $periodo_filtro
$whereConcepto  $whereTipoConcepto 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereClasePlanta
                    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_concep_liqui_detalle] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by concepto, id_tipo_doc, num_doc ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //concepto nomina
            if (isset($request['id_concep_nomina'])) {
                $whereConcepto = " AND tab0.id_concep_nomina = " . $request['id_concep_nomina'];
            } else {
                $whereConcepto = ' ';
            }
            //tipo concepto
            if (isset($request['id_tipo_concepto'])) {
                $whereTipoConcepto = " AND tab0.id_tipo_concepto = " . $request['id_tipo_concepto'];
            } else {
                $whereTipoConcepto = ' ';
            }
            //clase planta
            if (isset($request['id_clase_planta'])) {
                $whereClasePlanta = " AND tab0.id_clase_planta = " . $request['id_clase_planta'];
            } else {
                $whereClasePlanta = ' ';
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

   'TOTALES: ' || count(*) as num_doc,
   SUM(valor)  as valor

FROM (   

select 
tab0.*,
(select distinct periodo.periodo from no_periodo_v periodo where periodo.id_periodo = $periodo_filtro) AS PERIODO

from(

select 
tab.codigo as codigo_clapla,
tab.descripcion as descripcion_clapla, 
tab.id_clase_planta,
tab1.id_periodo,
tab4.id_tipo_concepto as id_tipo_concepto,
tab4.descripcion as tipo_concepto,
tab3.id_concep_nomina,
tab3.id_acreedor,
tab3.codigo,
tab3.descripcion,
tab3.codigo||' - '||tab3.descripcion AS CONCEPTO,
tab5.razon_soc as beneficiario,
tab2.id_tipo_doc,
tab2.num_doc as num_doc, 
tab2.nombre_apellido as nombre, 
tab1.valor_liquidado AS VALOR

from no_liquida_nomina tab1

left join no_datos_funcionario_v tab2 ON tab2.id_tipo_doc = tab1.id_tipo_doc and tab2.num_doc = tab1.num_doc
left join no_concep_nomina tab3 ON tab3.id_concep_nomina = tab1.id_concep_nomina
left join no_tipo_concepto tab4 ON tab4.id_tipo_concepto = tab3.id_tipo_concepto
left join interceros_v tab5 ON tab5.id_mae_ter = tab3.id_acreedor

left join (
         select 
         clapla.codigo,
         clapla.descripcion,
         nom.*,
          case when tab.num_doc is not null then 1 else 0 end as pago
          from no_nombramiento_v nom
          
          join no_clase_planta clapla
          on clapla.id_clase_planta = nom.id_clase_planta

          left join (select distinct
          pago.id_tipo_doc,
          pago.num_doc
          from no_pago_func pago
          where
          (select fecha_fin from no_periodo where id_periodo = $periodo_filtro) 
              between pago.fecha_activacion and nvl(pago.fecha_terminacion, (select fecha_fin from no_periodo where id_periodo = $periodo_filtro))
          )tab
          on tab.id_tipo_doc = nom.id_tipo_doc and tab.num_doc = nom.num_doc
)tab 
on tab.id_tipo_doc = tab1.id_tipo_doc and tab.num_doc = tab1.num_doc


)tab0

where tab0.id_periodo = $periodo_filtro
$whereConcepto  $whereTipoConcepto 
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereClasePlanta

$sortBy

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
